package es.uca.xmleye.gui.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   JFileChooser variant which disables the annoying single-click
   renaming "feature".

   Blatantly copied and pasted from the following URL:
   http://www.mikepot.com/1493.html

   @version 1.0 2009/04/13
*/

public class NoRenameFileChooser extends JFileChooser
{
    public NoRenameFileChooser()
    {
        JList list = findFileList(this);

        for (MouseListener l : list.getMouseListeners())
            {
                if (l.getClass().getName().indexOf("FilePane") >= 0)
                    {
                        list.removeMouseListener(l);
                        list.addMouseListener(new MyMouseListener(l));
                    }
            }
    }

    private JList findFileList(Component comp)
    {
        if (comp instanceof JList)
            return (JList)comp;

        if (comp instanceof Container)
            {
                for (Component child : ((Container)comp).getComponents())
                    {
                        JList list = findFileList(child);
                        if (list != null)
                            return list;
                    }
            }

        return null;
    }

    private class MyMouseListener extends MouseAdapter
    {
        MyMouseListener(MouseListener listenerChain)
        {
            m_listenerChain = listenerChain;
        }
        @Override
        public void mouseClicked(MouseEvent event)
        {
            if (event.getClickCount() > 1)
                m_listenerChain.mouseClicked(event);
        }
        private MouseListener m_listenerChain;
    }
}
